OGRE-Next: Ogre::v1::RibbonTrail Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
Ogre::v1::RibbonTrail Class Reference
Core » Effects

Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances. More...

`#include <OgreRibbonTrail.h>`

Inheritance diagram for Ogre::v1::RibbonTrail:
[legend]

## Public Types
typedef ConstVectorIterator< NodeList > | NodeIterator
typedef vector< Node * >::type | NodeList
Public Types inherited from Ogre::v1::BillboardChain
typedef vector< Element >::type | ElementList
enum | TexCoordDirection { TCD_U , TCD_V }
| The direction in which texture coordinates from elements of the chain are used. More...
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap

## Public Member Functions
| RibbonTrail (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, size_t maxElements=20, size_t numberOfChains=1, bool useTextureCoords=true, bool useVertexColours=true)
| Constructor (don't use directly, use factory)
| ~RibbonTrail () override
| destructor
virtual void | _timeUpdate (Real time)
| Perform any fading / width delta required; internal method.
virtual void | addNode (Node *n)
| Add a node to be tracked.
void | clearChain (size_t chainIndex) override
| Remove all elements of a given chain (but leave the chain intact).
virtual size_t | getChainIndexForNode (const Node *n)
| Get the chain index for a given Node being tracked.
virtual const ColourValue & | getColourChange (size_t chainIndex) const
| Get the per-second fading amount.
virtual const ColourValue & | getInitialColour (size_t chainIndex) const
| Get the starting ribbon colour.
virtual Real | getInitialWidth (size_t chainIndex) const
| Get the starting ribbon width in world units.
const String & | getMovableType () const override
| Overridden from MovableObject.
virtual NodeIterator | getNodeIterator () const
| Get an iterator over the nodes which are being tracked.
virtual Real | getTrailLength () const
| Get the length of the trail.
virtual Real | getWidthChange (size_t chainIndex) const
| Get the change in ribbon width per second.
void | nodeDestroyed (const Node *node) override
void | nodeUpdated (const Node *node) override
virtual void | removeNode (Node *n)
| Remove tracking on a given node.
virtual void | setColourChange (size_t chainIndex, const ColourValue &valuePerSecond)
| Enables / disables fading the trail using colour.
virtual void | setColourChange (size_t chainIndex, Real r, Real g, Real b, Real a)
| Enables / disables fading the trail using colour.
virtual void | setInitialColour (size_t chainIndex, const ColourValue &col)
| Set the starting ribbon colour for a given segment.
virtual void | setInitialColour (size_t chainIndex, Real r, Real g, Real b, Real a=1.0)
| Set the starting ribbon colour.
virtual void | setInitialWidth (size_t chainIndex, Real width)
| Set the starting ribbon width in world units.
void | setMaxChainElements (size_t maxElements) override
| Set the maximum number of chain elements per chain.
void | setNumberOfChains (size_t numChains) override
| Set the number of chain segments (this class can render multiple chains at once using the same material).
virtual void | setTrailLength (Real len)
| Set the length of the trail.
virtual void | setWidthChange (size_t chainIndex, Real widthDeltaPerSecond)
| Set the change in ribbon width per second.
Public Member Functions inherited from Ogre::v1::BillboardChain
| BillboardChain (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, size_t maxElements=20, size_t numberOfChains=1, bool useTextureCoords=true, bool useColours=true, bool dynamic=true)
| Constructor (don't use directly, use factory)
| ~BillboardChain () override
| Destructor.
void | _updateRenderQueue (RenderQueue *, Camera *camera, const Camera *lodCamera) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
virtual void | addChainElement (size_t chainIndex, const Element &billboardChainElement)
| Add an element to the 'head' of a chain.
virtual void | clearAllChains ()
| Remove all elements from all chains (but leave the chains themselves intact).
const AxisAlignedBox & | getBoundingBox () const
virtual const Element & | getChainElement (size_t chainIndex, size_t elementIndex) const
| Get the detail of a chain element.
virtual bool | getDynamic () const
| Gets whether or not the buffers created for this object are suitable for dynamic alteration.
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
virtual size_t | getMaxChainElements () const
| Get the maximum number of chain elements per chain.
virtual size_t | getNumberOfChains () const
| Get the number of chain segments (this class can render multiple chains at once using the same material).
virtual size_t | getNumChainElements (size_t chainIndex) const
| Returns the number of chain elements.
virtual const Real * | getOtherTextureCoordRange () const
| Get the range of the texture coordinates generated across the width of the chain elements.
void | getRenderOperation (RenderOperation &, bool casterPass) override
| Gets the render operation required to send this object to the frame buffer.
Real | getSquaredViewDepth (const Camera *cam) const
virtual TexCoordDirection | getTextureCoordDirection ()
| Gets the direction in which texture coords specified on each element are deemed to run.
virtual bool | getUseTextureCoords () const
| Gets whether texture coordinate information should be included in the final buffers generated.
virtual bool | getUseVertexColours () const
| Gets whether vertex colour information should be included in the final buffers generated.
void | getWorldTransforms (Matrix4 *) const override
| Gets the world transform matrix / matrices for this renderable object.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys) override
| Called just prior to the Renderable being rendered.
virtual void | removeChainElement (size_t chainIndex)
| Remove an element from the 'tail' of a chain.
virtual void | setDynamic (bool dyn)
| Sets whether or not the buffers created for this object are suitable for dynamic alteration.
void | setFaceCamera (bool faceCamera, const Vector3 &normalVector=Vector3::UNIT_X)
| Sets whether the billboard should always be facing the camera or a custom direction set by each point element.
virtual void | setOtherTextureCoordRange (Real start, Real end)
| Set the range of the texture coordinates generated across the width of the chain elements.
virtual void | setTextureCoordDirection (TexCoordDirection dir)
| Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.
virtual void | setUseTextureCoords (bool use)
| Sets whether texture coordinate information should be included in the final buffers generated.
virtual void | setUseVertexColours (bool use)
| Sets whether vertex colour information should be included in the final buffers generated.
virtual void | updateChainElement (size_t chainIndex, size_t elementIndex, const Element &billboardChainElement)
| Update the details of an existing chain element.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only)
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only)
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum()
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum()
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)
Public Member Functions inherited from Ogre::Node::Listener
| Listener ()
virtual | ~Listener ()
virtual void | nodeAttached (const Node *)
| Node has been attached to a parent.
virtual void | nodeDetached (const Node *)
| Node has been detached from a parent.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances.

Remarks
  An instance of this class will watch one or more Node instances, and automatically generate a trail behind them as they move. Because this class can monitor multiple modes, it generates its own geometry in world space and thus, even though it has to be attached to a SceneNode to be visible, changing the position of the scene node it is attached to makes no difference to the geometry rendered.

  The 'head' element grows smoothly in size until it reaches the required size, then a new element is added. If the segment is full, the tail element shrinks by the same proportion as the head grows before disappearing.

  Elements can be faded out on a time basis, either by altering their colour or altering their alpha. The width can also alter over time.

  'v' texture coordinates are fixed at 0.0 if used, meaning that you can use a 1D texture to 'smear' a colour pattern along the ribbon if you wish. The 'u' coordinates are by default (0.0, 1.0), but you can alter this using setOtherTexCoordRange if you wish.

## Member Typedef Documentation

## ◆ NodeIterator

typedef ConstVectorIterator<NodeList> Ogre::v1::RibbonTrail::NodeIterator

## ◆ NodeList

typedef vector<Node*>::type Ogre::v1::RibbonTrail::NodeList

## Constructor & Destructor Documentation

## ◆ RibbonTrail()

Ogre::v1::RibbonTrail::RibbonTrail | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager,
|  | size_t | maxElements = 20,
|  | size_t | numberOfChains = 1,
|  | bool | useTextureCoords = true,
|  | bool | useVertexColours = true )

Constructor (don't use directly, use factory)

Parameters

  name | The name to give this object
  maxElements | The maximum number of elements per chain
  numberOfChains | The number of separate chain segments contained in this object, ie the maximum number of nodes that can have trails attached
  useTextureCoords | If true, use texture coordinates from the chain elements
  useVertexColours | If true, use vertex colours from the chain elements (must be true if you intend to use fading)

## ◆ ~RibbonTrail()

Ogre::v1::RibbonTrail::~RibbonTrail | ( |  | ) |
| override

destructor

## Member Function Documentation

## ◆ _timeUpdate()

virtual void Ogre::v1::RibbonTrail::_timeUpdate | ( | Real | time | ) |
| virtual

Perform any fading / width delta required; internal method.

## ◆ addNode()

virtual void Ogre::v1::RibbonTrail::addNode | ( | Node * | n | ) |
| virtual

Add a node to be tracked.

Parameters

  n | The node that will be tracked.

## ◆ clearChain()

void Ogre::v1::RibbonTrail::clearChain | ( | size_t | chainIndex | ) |
| overridevirtual

Remove all elements of a given chain (but leave the chain intact).

Reimplemented from Ogre::v1::BillboardChain.

## ◆ getChainIndexForNode()

virtual size_t Ogre::v1::RibbonTrail::getChainIndexForNode | ( | const Node * | n | ) |
| virtual

Get the chain index for a given Node being tracked.

## ◆ getColourChange()

virtual const ColourValue & Ogre::v1::RibbonTrail::getColourChange | ( | size_t | chainIndex | ) | const
| virtual

Get the per-second fading amount.

## ◆ getInitialColour()

virtual const ColourValue & Ogre::v1::RibbonTrail::getInitialColour | ( | size_t | chainIndex | ) | const
| virtual

Get the starting ribbon colour.

## ◆ getInitialWidth()

virtual Real Ogre::v1::RibbonTrail::getInitialWidth | ( | size_t | chainIndex | ) | const
| virtual

Get the starting ribbon width in world units.

## ◆ getMovableType()

const String & Ogre::v1::RibbonTrail::getMovableType | ( |  | ) | const
| overridevirtual

Overridden from MovableObject.

Reimplemented from Ogre::v1::BillboardChain.

## ◆ getNodeIterator()

virtual NodeIterator Ogre::v1::RibbonTrail::getNodeIterator | ( |  | ) | const
| virtual

Get an iterator over the nodes which are being tracked.

## ◆ getTrailLength()

virtual Real Ogre::v1::RibbonTrail::getTrailLength | ( |  | ) | const
| inlinevirtual

Get the length of the trail.

## ◆ getWidthChange()

virtual Real Ogre::v1::RibbonTrail::getWidthChange | ( | size_t | chainIndex | ) | const
| virtual

Get the change in ribbon width per second.

## ◆ nodeDestroyed()

void Ogre::v1::RibbonTrail::nodeDestroyed | ( | const Node * | node | ) |
| overridevirtual

See also
  Node::Listener::nodeDestroyed

Reimplemented from Ogre::Node::Listener.

## ◆ nodeUpdated()

void Ogre::v1::RibbonTrail::nodeUpdated | ( | const Node * | node | ) |
| overridevirtual

See also
  Node::Listener::nodeUpdated

Reimplemented from Ogre::Node::Listener.

## ◆ removeNode()

virtual void Ogre::v1::RibbonTrail::removeNode | ( | Node * | n | ) |
| virtual

Remove tracking on a given node.

## ◆ setColourChange() [1/2]

virtual void Ogre::v1::RibbonTrail::setColourChange | ( | size_t | chainIndex,
|  | const ColourValue & | valuePerSecond )
| virtual

Enables / disables fading the trail using colour.

Parameters

  chainIndex | The index of the chain
  valuePerSecond | The amount to subtract from colour each second

## ◆ setColourChange() [2/2]

virtual void Ogre::v1::RibbonTrail::setColourChange | ( | size_t | chainIndex,
|  | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a )
| virtual

Enables / disables fading the trail using colour.

Parameters

  chainIndex | The index of the chain
  r,g,b,a | The amount to subtract from each colour channel per second

## ◆ setInitialColour() [1/2]

virtual void Ogre::v1::RibbonTrail::setInitialColour | ( | size_t | chainIndex,
|  | const ColourValue & | col )
| virtual

Set the starting ribbon colour for a given segment.

Parameters

  chainIndex | The index of the chain
  col | The initial colour

Note
  Only used if this instance is using vertex colours.

## ◆ setInitialColour() [2/2]

virtual void Ogre::v1::RibbonTrail::setInitialColour | ( | size_t | chainIndex,
|  | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = 1.0 )
| virtual

Set the starting ribbon colour.

Parameters

  chainIndex | The index of the chain
  r,b,g,a | The initial colour

Note
  Only used if this instance is using vertex colours.

## ◆ setInitialWidth()

virtual void Ogre::v1::RibbonTrail::setInitialWidth | ( | size_t | chainIndex,
|  | Real | width )
| virtual

Set the starting ribbon width in world units.

Parameters

  chainIndex | The index of the chain
  width | The initial width of the ribbon

## ◆ setMaxChainElements()

void Ogre::v1::RibbonTrail::setMaxChainElements | ( | size_t | maxElements | ) |
| overridevirtual

Set the maximum number of chain elements per chain.

Reimplemented from Ogre::v1::BillboardChain.

## ◆ setNumberOfChains()

void Ogre::v1::RibbonTrail::setNumberOfChains | ( | size_t | numChains | ) |
| overridevirtual

Set the number of chain segments (this class can render multiple chains at once using the same material).

Reimplemented from Ogre::v1::BillboardChain.

## ◆ setTrailLength()

virtual void Ogre::v1::RibbonTrail::setTrailLength | ( | Real | len | ) |
| virtual

Set the length of the trail.

Remarks
  This sets the length of the trail, in world units. It also sets how far apart each segment will be, ie length / max_elements.

Parameters

  len | The length of the trail in world units

## ◆ setWidthChange()

virtual void Ogre::v1::RibbonTrail::setWidthChange | ( | size_t | chainIndex,
|  | Real | widthDeltaPerSecond )
| virtual

Set the change in ribbon width per second.

Parameters

  chainIndex | The index of the chain
  widthDeltaPerSecond | The amount the width will reduce by per second

The documentation for this class was generated from the following file:

- OgreRibbonTrail.h